/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date  $
 * $RCSfile: drv_hdmi.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/
#ifndef _DRV_EDID_H_
#define _DRV_EDID_H_

#define HDMI_EDID_MUX_SEL
//-----------------------------------------------------------------------------
// Type definitions
//-----------------------------------------------------------------------------
#define HDMIEDID_DATA_BLOCK_START_INDEX 4
#define HDMIEDID_AUDIO_DATA_BLOCK_TAG_CODE 1
#define HDMIEDID_AUDIO_DATA_BLOCK_SIZE 3
#define HDMIEDID_AUDIO_EAC3_FMT_TYPE 0xA
#define HDMIEDID_AUDIO_ATMOS_BIT_MASK 0x1
#define HDMIEDID_CHECKSUM_INDEX 127
#define HDMIEDID_INVALID_DATA_INDEX 127

#define HDMIEDID_DATA_BLOCK_TAG_CODE_MASK_VALUE(_a_) (((_a_)&0xE0)>>5)
#define HDMIEDID_DATA_BLOCK_LENGTH_MASK_VALUE(_a_) ((_a_)&0x1F)
#define HDMIEDID_AUDIO_FMT_TYPE_MASK_VALUE(_a_) (((_a_)&0x78)>>3)
#define HDMIEDID_AUDIO_ATMOS_BIT_MASK_VALUE(_a_) ((_a_)&0x1)

typedef enum
{
    HDMI2_EDID_TYPE_STANDARD,
    HDMI2_EDID_TYPE_ENHANCE,
} HDMI2_EDID_TYPE_T;

typedef enum {
    HDMI_EDID20_TYPE_STANDARD,//no HF_VSDB
    HDMI_EDID20_TYPE_ENHANCE,//has HF_VSDB
    MHL_EDID
}HDMI_EDID_CHECK_MODE_T;

extern UINT8 u1HDMIEDIDGetAtmosEnable(void);
extern void vHDMIEDIDSetAtmosEnable(UINT8 u1Enable);
extern UINT8 u1HDMIEDIDCalCheckSum(UINT8 *pu1EdidBlockx);
extern void vHDMIEDIDReplaceAtmosBit(UINT8 *pu1EdidBlock1,UINT8 u1AtmosEnable);
extern void vHDMI14WriteEDIDToSram(UINT8 *pu1Edid);
#ifdef CC_HDMI_2_0_SUPPORT
extern void vHDMI20WriteEDIDToSram(UINT8 *pu1Edid);
extern void vHDMI20LoadEDID14(void);
extern void vHDMI20LoadEDID20(void);
extern void vHDMI20Write3G420EDIDToSram(UINT8 *pu1Edid);

extern void vHDMI20EDIDMuxSel(void);
extern void vHDMI20LoadEDID3G420(void);
extern void  vHDMI20EDIDDisable3G420(BOOL fgDisable);
#endif
extern void vMHLWriteEDIDToSram(UINT8 *pu1Edid);
extern void vHDMI14EDIDDisable(BOOL fgDisable);
extern void vHDMI20EDIDDisable(BOOL fgDisable);
#if defined(CC_S_PLATFORM) && defined(CC_PHX_CUST)
extern void vHDMI20WriteEDIDToSramForSony(UINT8 ePort,UINT8 *pu1Edid);
extern void vHDMI20EDIDMuxSelForSony(void);
extern void vHDMI20LoadEDID(UINT8 ePort);
extern void vHDMI_INTERNAL_EDID_Init_Sony(void);
#else      
extern void vHDMI_INTERNAL_EDID_Init(void);        
#endif
extern void vMHL_INTERNAL_EDID_Init(void);
extern void vMHL20LoadEDID20(void);
#ifndef CC_MTK_LOADER
extern UINT8 * bMHLGetEDIDTable(void);
extern UINT8 u1HDMIEDIDCheckValid(HDMI_EDID_CHECK_MODE_T eEdidMode);
extern BOOL fgHDMIEDIDHandleSAD(BOOL fgSet,UINT8 u1FormatNum,UINT8 *pu1AudioDataBlock);
#endif
#endif

