/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*! @file u_hbbtv_drm.h
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/11/26 $
 *  $Author: dtvbm11 $
 *
 *  @par Description:This header file contains HBBTV streaming exported constants, macros, and types.
 */
/*----------------------------------------------------------------------------*/
#ifndef _U_HBBTV_DRM_H_
#define _U_HBBTV_DRM_H_

#include <features.h>

__BEGIN_DECLS

#include "u_common.h"
#include "mtkdrm.h"

#define HBBTV_DRM_LICENSE_URL_LEN   			  (1024)
#define HBBTV_DRM_PLAYREADY_KEY_NUM   			  (16)
#define HBBTV_DRM_PLAYREADY_DECRYPT_CONTEXT_NUM   (16)

#define HBBTV_DRM_OIPF_ID_PREFIX    "urn:dvb:casystemid:"
#define HBBTV_DRM_OIPF_ID_PLAYREADY (HBBTV_DRM_OIPF_ID_PREFIX "19219")
#define HBBTV_DRM_OIPF_ID_MARLIN    (HBBTV_DRM_OIPF_ID_PREFIX "19188")

typedef void (*pf_drm_msg_nfy)( MTKDRM_RESULT_E code,
                                 const char *result_msg,
                                 void *ref );



typedef struct _HBBTV_DRM_PLAYREADY_ENCRYPINFO_T
{
     MTKDRM_INITIATOR_TYPE   e_initiator_type;
     PLAYREADY_ENCRYPT_INFO  t_playready_key[HBBTV_DRM_PLAYREADY_KEY_NUM];
     PLAYREADY_DECRYPT_INFO  t_playready_decrypt_context[HBBTV_DRM_PLAYREADY_DECRYPT_CONTEXT_NUM];
     CHAR                    aui1_CID[HBBTV_DRM_PLAYREADY_KEY_NUM][MTKDRM_MARLIN_CONTENT_ID_LENGTH];
     UINT8                   ui1_key_num;


}PLAYREADY_ENCRYPINFO_T;

typedef struct _HBBTV_DRM_CIPLUS_ENCRYPINFO_T
{
     UINT16					ui2_casystemid;
}CIPLUS_ENCRYPINFO_T;

typedef struct _HBBTV_DRM_ENCRYPINFO_T
{
    MTKDRM_TYPE_E           t_drm_type;
    MTKDRM_HANDLE_T         t_drm_handle;

    union
    {
       PLAYREADY_ENCRYPINFO_T  t_playready_encrypinfo;
	   CIPLUS_ENCRYPINFO_T				t_ciplus_encrypinfo;
    }u_data;

}  HBBTV_DRM_ENCRYPINFO_T;

typedef enum
{
    HBBTV_DRM_RIGHTS_ISSUER_URL,
    HBBTV_DRM_SLIENT_RIGHTS_URL,
    HBBTV_DRM_CONTENT_ID,
    HBBTV_DRM_PREVIEW_RIGHTS_URL,
    HBBTV_DRM_PRIVATE_DATA,
    HBBTV_DRM_DONOT_RECORD,
    HBBTV_DRM_DONOT_TIMESHIFT,
    HBBTV_DRM_CONTROL_INFO_TYPE_NUM
} HBBTV_DRM_CONTROL_INFO_TYPE_E;

typedef struct _HBBTV_DRM_CONTROL_INFO_T
{
    HBBTV_DRM_CONTROL_INFO_TYPE_E     e_control_info_type;
    VOID                              *pv_data;
    UINT32                            ui4_data_len;
}  HBBTV_DRM_CONTROL_INFO_T;
/*------------------------------------------------------------------*/
/*! @enum HBBTV_DRM_CI_NFY_COND_T
 *  @li@c  HBBTV_DRM_CIPLUS_NFY_COND_CARD_INSERT                           -notify that the Card is insterted,
 *                                                                                     pv_data in x_ci_nfy_fct is NULL
 *  @li@c  HBBTV_DRM_CIPLUS_NFY_COND_CARD_REMOVE                           -notify that the Card is removed
 *                                                                                     pv_data in x_ci_nfy_fct is NULL
 *  @li@c  HBBTV_DRM_CIPLUS_NFY_COND_PARENTAL_CONTROL_INFO   -notify cam sent parental control info
 *                                                                                     pv_data in x_ci_nfy_fct is HBBTV_DRM_CIPLUS_PARENTAL_CONTROL_INFO* value
*  @li@c  HBBTV_DRM_CIPLUS_NFY_COND_SYSTEM_INFO   -notify cam sent system info
*												    pv_data in x_ci_nfy_fct is HBBTV_DRM_CIPLUS_SYSTEM_INFO* value
*  @li@c  HBBTV_DRM_CIPLUS_NFY_COND_RIGHTS_INFO   -notify cam sent rights info
*												    pv_data in x_ci_nfy_fct is HBBTV_DRM_CIPLUS_RIGHTS_INFO* value
*/

typedef enum
{
    HBBTV_DRM_CIPLUS_NFY_COND_CARD_INSERT = 0,
    HBBTV_DRM_CIPLUS_NFY_COND_CARD_REMOVE,
    HBBTV_DRM_CIPLUS_NFY_COND_PARENTAL_CONTROL_INFO,
    HBBTV_DRM_CIPLUS_NFY_COND_SYSTEM_INFO,
    HBBTV_DRM_CIPLUS_NFY_COND_RIGHTS_INFO
}HBBTV_DRM_CIPLUS_NFY_COND_T;

typedef struct
{
   uint8_t access_status;
   uint8_t rating_type;
   uint8_t rating_value;
   uint8_t *country_codes;
   uint16_t country_codes_len;
   uint8_t *parental_control_url;
   uint16_t url_len;
} HBBTV_DRM_CIPLUS_PARENTAL_CONTROL_INFO;

typedef struct
{
   uint16_t ca_system_id;
   uint8_t  access_status;
   uint8_t *rights_issuer_url;
   uint16_t url_len;
} HBBTV_DRM_CIPLUS_RIGHTS_INFO;

typedef struct
{
   uint16_t ca_system_id;
   uint8_t *ca_info;
   uint16_t ca_info_len;
} HBBTV_DRM_CIPLUS_SYSTEM_INFO;

typedef void (*hbbtv_drm_ciplus_nfy_fct)(
    HBBTV_DRM_CIPLUS_NFY_COND_T   e_nfy_cond,
    void*               pv_data,
    void*				pv_tag);

__END_DECLS

#endif /* _U_HBBTV_DRM_H_ */
