/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 * $RCSfile: x_feature_query_api.h,v $
 * $Revision: #3 $
 * $Date: 2016/10/19 $
 * $Author: xiangshu.wang $
 *
 * Description:
 *         This file contains function for feature query
 *-----------------------------------------------------------------*/

#ifndef _X_FEATURE_QUERY_API_H_
#define _X_FEATURE_QUERY_API_H_
/*-----------------------------------------------------------------------------
 *  include files
 *---------------------------------------------------------------------------*/
#include "x_common.h"
//#include "u_cfg_parser.h"
#include "x_os.h"

/*-----------------------------------------------------------------------------
* get x_feature_tv_bypass_is_enable already configed or not
* return value:
*   TRUE: tv_bypass is enable, macro "MW_TV_AV_BYPASS_SUPPORT" is defined
*   FALSE: tv_bypass is not enable
-----------------------------------------------------------------------------*/
extern BOOL x_feature_tv_bypass_is_enable(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_time_measurement_is_enable already configed or not
* return value:
*   TRUE: time_measurement is enable, macro "TIME_MEASUREMENT" is defined
*   FALSE: time_measurement is not enable
-----------------------------------------------------------------------------*/
extern BOOL x_feature_time_measurement_is_enable(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_isdb_support already configed or not
* return value:
*   TRUE: isdb is support, macro "MW_ISDB_SUPPORT" is defined
*   FALSE: isdb is not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_isdb_support(VOID );

/****************************RECORD & TSHIFT**********************************/
/*-----------------------------------------------------------------------------
* get x_feature_is_time_shift_support already configed or not
* return value:
*   TRUE: time shift is support, macro "TIME_SHIFT_SUPPORT" is defined
*   FALSE: time shift not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_time_shift_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_dtv_record_support already configed or not
* return value:
*   TRUE: record is support, macro "SYS_RECORD_SUPPORT" is defined
*   FALSE: record not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_dtv_record_support(VOID );

/*********************************CI******************************************/
/*-----------------------------------------------------------------------------
* get x_feature_is_ci_plus_support already configed or not
* return value:
*   TRUE: ci plus is support, macro "CI_PLUS_SUPPORT" is defined
*   FALSE: ci plus not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_ci_plus_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_ci_plus_v13_support already configed or not
* return value:
*   TRUE: ci plus v1.3 is support, macro "CI_PLUS_V13_SUPPORT" is defined
*   FALSE: ci plus v1.3 not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_ci_plus_v13_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_dvbt_ci_enable already configed or not
* return value:
*   TRUE: dvbt ci is enable, macro "DVBT_CI_ENABLE" is defined
*   FALSE: dvbt ci is not enable
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_dvbt_ci_enable(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_ci_plus_tz_support already configed or not
* return value:
*   TRUE: ci plus tz is support, macro "CI_PLUS_TZ_SUPPORT" is defined
*   FALSE: ci plus tz not support
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_ci_plus_tz_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_multi_ts_support already configed or not
* return value:
*   TRUE: multi ts is support, macro "MW_SB_MULTI_TS_SUPPORT" is constant defined
*   FALSE: multi ts not support
* Note: this defined defined macro "MW_SB_UNDEF_MULTI_TS_SUPPORT", if the macro
*       "MW_SB_UNDEF_MULTI_TS_SUPPORT" is defined, "MW_SB_MULTI_TS_SUPPORT" will
*       be defined, or it will not be defined.
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_multi_ts_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_enable_multimedia already configed or not
* return value:
*   TRUE: multimedia is enabled, macro "ENABLE_MULTIMEDIA" is defined
*   FALSE: multimedia is disabled
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_enable_multimedia(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_last_memory_support already configed or not
* return value:
*   TRUE: multimedia last memory is supported, macro "MM_LAST_MEMORY_SUPPORT" is defined
*   FALSE: multimedia last memory is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_last_memory_support(VOID );

/*-----------------------------------------------------------------------------
* get x_feature_is_inet_support already configed or not
* return value:
*   TRUE: network is supported, macro "INET_SUPPORT" is defined
*   FALSE: network is not supported
-----------------------------------------------------------------------------*/
extern BOOL x_feature_is_inet_support(VOID );

#endif

